﻿class Ventana {
	private var _padre:MovieClip;
	private var miVentana:MovieClip;
	private var n:Number;
	private var h:Number;
	private var w:Number;
	private var ch:Number;
	private var cw:Number;
	
	function Ventana(h, w, mc, titulo, padre, n) {
		this.n=n;
		this._padre=padre;
		
		this._padre.createEmptyMovieClip("ventana" + n,n + 1100);
			this.miVentana = this._padre["ventana"+n];
//			this.miVentana._height = h;
//			this.miVentana._width = w;
		this.miVentana.createEmptyMovieClip("BarraSuperior",n + 1150);
			this.miVentana.BarraSuperior._x= 0;
			this.miVentana.BarraSuperior._y= 0;
			this.miVentana.BarraSuperior.onMouseDown = function(){
				if (this._xmouse>=0 && this._xmouse<=w && this._ymouse>=0 && this._ymouse<=23)
					startDrag(this._parent);
			}
			this.miVentana.BarraSuperior.onMouseUp = function(){
				stopDrag();
			}
		this.miVentana.BarraSuperior.attachMovie("BordeSuperior", "borde", n + 1100);
			this.miVentana.BarraSuperior.borde._x= 0;
			this.miVentana.BarraSuperior.borde._y= 0;
			this.miVentana.BarraSuperior.borde._height = 23;
			this.miVentana.BarraSuperior.borde._width = w;
		this.miVentana.BarraSuperior.attachMovie("Titulo", "titulo", n + 1200);
			this.miVentana.BarraSuperior.titulo._x= 5;
			this.miVentana.BarraSuperior.titulo._y= 5;
			
		this.miVentana.createEmptyMovieClip("cuerpo",n + 1100);
		this.miVentana.cuerpo.attachMovie("Cuerpo", "fondo",n + 1300);
			this.miVentana.cuerpo.fondo._x= 0;
			this.miVentana.cuerpo.fondo._y= 23;
			this.miVentana.cuerpo.fondo._height = h-20;
			this.miVentana.cuerpo.fondo._width = w;
		this.miVentana.cuerpo.attachMovie(mc, "componente",n + 1400);
			this.miVentana.cuerpo.componente._x= 5;
			this.miVentana.cuerpo.componente._y= 25;
		
		this.miVentana.path = this;
		this.titulo = titulo

		this.miVentana.createEmptyMovieClip("vida",1);
		this.miVentana.vida._padre=this;
		this.miVentana.vida.onEnterFrame = 	function (){
			this._padre.calcMover(this._padre.w, this._padre.h);
		};
		this.miVentana.vida.play();
	
		this.miVentana.attachMovie("BotonCerrar", "btn_cerrar",n+2000);
			this.miVentana.btn_cerrar._height = 14;
			this.miVentana.btn_cerrar._width = 15;
			this.miVentana.btn_cerrar._x = w - 18;
			this.miVentana.btn_cerrar._y = 4.5;
			this.miVentana.btn_cerrar.onPress = function (evt:Object){
				this._parent.createEmptyMovieClip("muerte",1);
				this._parent.muerte.onEnterFrame = function (){
					this._parent.path.calcRecoger(this._parent.path.w, this._parent.path.h);
				};
				this.miVentana.muerte.path = this._parent.path;
			};

		this.miVentana.attachMovie("BotonMiminizar", "btn_min",n+3000);
			this.miVentana.btn_min._height = 14;
			this.miVentana.btn_min._width = 15;
			this.miVentana.btn_min._x = w - 36;
			this.miVentana.btn_min._y = 4.5;
			this.miVentana.btn_min.onPress = function (evt:Object){
				this._parent.createEmptyMovieClip("miminiza",1);
				if (Math.round(this._parent.cuerpo._height)>0)
				{
					this._parent.miminiza.onEnterFrame = function(){
						this._parent.path.calcEsconder(this._parent.path.cw, this._parent.path.ch);
					};
				}
				else
				{
					this._parent.miminiza.onEnterFrame = function(){
						this._parent.path.calcMostrar(this._parent.path.cw, this._parent.path.ch);
					};
				}
				this.miVentana.miminiza.path = this._parent.path;
			};
			
		this.cw = this.miVentana.cuerpo._width;
		this.ch = this.miVentana.cuerpo._height;
		this.w = this.miVentana._width;
		this.h = this.miVentana._height;
		this.miVentana._height = 0;
		this.miVentana._width = 0;
	}
	
	function calcMover(w, h){
		this.miVentana._height += (h - this.miVentana._height)/5;
		this.miVentana._width += (w - this.miVentana._width)/5;
		//trace("w=" + Math.round(this.miVentana._width) + "/" + Math.round(w));
		//trace("h=" + Math.round(this.miVentana._height) + "/" + Math.round(h));
		if (Math.round(this.miVentana._width) == Math.round(w) || Math.round(this.miVentana._height) == Math.round(h)) { 
			delete this.miVentana.vida.onEnterFrame;
			this.miVentana.vida.removeMovieClip();
		}
	}

	function calcRecoger(w, h){
		var dish, disw;
		dish=(this.miVentana._height)/3;
		disw=(this.miVentana._width)/3;
		this.miVentana._height -= dish;
		this.miVentana._width -= disw;
		this.miVentana._y += dish/2;
		this.miVentana._x += disw/2;
		if (Math.round(this.miVentana._width) <= 0 || Math.round(this.miVentana._height) <= 0) { 
			delete this.miVentana.muerte.onEnterFrame;
			this.miVentana.muerte.unloadMovie();
			this.miVentana.unloadMovie();
		}
	}

	function calcEsconder(w, h){
		this.miVentana.cuerpo._height -= (this.miVentana.cuerpo._height)/2;
		if (Math.round(this.miVentana._height) <= 0) { 
			delete this.miVentana.miminiza.onEnterFrame;
			this.miVentana.miminiza.unloadMovie();
		}
	}
	
	function calcMostrar(w, h){
		this.miVentana.cuerpo._height += (h-this.miVentana.cuerpo._height)/3;
		if (Math.round(this.miVentana._height) >= Math.round(h)) { 
			delete this.miVentana.miminiza.onEnterFrame;
			this.miVentana.miminiza.unloadMovie();
			this.miVentana.cuerpo._height = h;
		}
	}
	function set titulo(t:String){
		this.miVentana.BarraSuperior.titulo.texto.text=t;
	}
	function get titulo():String{
		return this.miVentana.BarraSuperior.titulo.texto.text;
	}
	function set _x(t:Number){
		this.miVentana._x=t;
	}
	function get _x():Number{
		return this.miVentana._x;
	}
	function set _y(t:Number){
		this.miVentana._y=t;
	}
	function get _y():Number{
		return this.miVentana._y;
	}
	function set _height(t:Number){
		this.miVentana._height=t;
		this.h=t;
	}
	function get _height():Number{
		return this.miVentana._height;
	}
	function set _width(t:Number){
		this.miVentana._width=t;
		this.w=t;
	}
	function get _width():Number{
		return this.miVentana._width;
	}
	function set contentPath(mc:MovieClip){
		this.miVentana.cuerpo.componente._x= 5;
		this.miVentana.cuerpo.componente._y= 25;
		this.miVentana.cuerpo.componente = mc;
	}
	function get contentPath():MovieClip{
		return this.miVentana.cuerpo.componente;
	}
}
